' EduMite.bas for EduMite PCB: FONT 1 is 60x26; FONT7 is 80x40

option explicit
dim integer i,j,k,l,m,n,iCol,iRow,x,y,iBtnFG,iBtnBG,kBtnBG=RGB(red),kBtnFG=RGB(yellow)
dim integer fH,fW,iFont,nChRow,nRows,lastSW
dim string a,c,d,e,f,g,h,s,lastSecond$
dim float fLDR,fPOT,fTMP,fHUM,fDSTMP, fLastLDR,fLastPOT,fLastTMP,fLastDSTMP
Dim b%(14)=(RGB(red), RGB(green), RGB(blue), RGB(Yellow), 0,0,0,0,0,0,0,0,0,0,0)
b%(5)=RGB(gold): b%(6)=RGB(magenta): b%(7)=RGB(brown): b%(8)=RGB(pink)
b%(9)=RGB(salmon): b%(10)=RGB(orange):b%(11)=RGB(grey):b%(12)=RGB(white)
b%(13)=RGB(lightgrey): b%(14)=RGB(beige): b%(4)=RGB(cyan)
const false=0
const true=1

Dim integer rotatedright=false, rotatedleft=false, resetenc=true

Dim integer tickState, tick, lastTick, fastTick, lastFast
' define pin numbers
const pCOM1Tx=1,pCOM1Rx=2,pBUZZER=4,pSERVO=5,pRGB_R=6,pPUSHBTN=7,pRGB_G=9
const pPS2_C=11,pPS2_D=12,pRE_C=14,pRE_D=15,pRE_SW=16,pHUMID=17,pDS18B20=19
const pWS2812=20,pPOT=31,pLDR=32,pRGB_B=34
const cTurquoise=rgb(64,224,208),cBlack=0

'  dim integer pRE_D=3 ' pRE_C: swap the pin definitions as required to get the correct sense of rotation
'  dim integer pRE=2 ' pRE_D: rotary encoder pushbutton--active low

setpin pCOM1Tx,dout: setpin pCOM1Rx,dout ' if used for LEDs, not serial
setpin ppRGB_R,dout: pRGB_G,dout: setpin pRGB_B,dout
setpin pBUZZER,dout: setpin pPUSHBTN,din,pullup
setpin pLDR,ain: setpin pPOT,ain

init:
setpin pRE_C,intB,RE_int 'enable interrupts on both edges of both pins
setpin pRE_D,intB,RE_int
setpin pRE_SW,din,pullup
rotatedright=false
rotatedleft=false
resetenc=true
tempr start pDS18B20
iFont=7
font iFont
fH=mm.fontheight: fW=mm.fontwidth
nChRow=mm.hres/fW: nRows=mm.vres/fH
? "Font ";iFont;"; width, height, chars/row: ";fW;" ";fH;" ";nChRow;"x";nRows
CLS RGB(red)

MAIN:
  Do
    a=mid$(time$,7,2)
    if a<>lastSecond$ then
      fDSTMP=tempr(pDS18B20)
      if fLastDSTMP<>fDSTMP then
        text 10,fH*3,str$(fDSTMP,10,1),,2,,cBlack,cTurquoise
        fLastDSTMP=fDSTMP
      endif
      tempr start pDS18B20
      bitbang humid, pHUMID,fTMP,fHUM
      if fLastTMP<>fDSTMP then
        text 10,fH*5,str$(fDSTMP,10,1),,2,,cBlack,cTurquoise
        fLastTMP=fTMP
      endif
      if fLastHUM<>fHUM then
        text 10,fH*7,str$(fHUM,10,1),,2,,cBlack,cTurquoise
        fLastHUM=fHUM
      endif
      fPOT=pin(pPOT)
      if fLastPOT<>fPOT then
        text 10,fH*9,str$(fPOT,10,1),,2,,cBlack,cTurquoise
        fLastPOT=fPOT
      endif
      i=pin(pPUSHBTN)
      if lastSW<>i then
        fLastSW=i
        text 10,fH*11,str$(fLastSW),,2,,cBlack,cTurquoise
      endif
 
      lastSecond$=a
    endif
  Loop

sub RE_int ' rotary encoder interrupt
' code: https://www.thebackshed.com/forum/ViewTopic.php?TID=10568&PID=124755#124755
' from matherp & goc
  LOCAL integer pin0,pin1
rint2:
  pin0=NOT pin(pRE_C) 'reverse sense to get positive logic
  pin1=NOT pin(pRE_D)
  if pin0 then
    if pin1 and not resetenc then 'pRE_C and pRE_D both active
      if rotatedleft and not rotatedright then
        value=fix(max(1,value-1)) ' minimum of 1
        rotatedleft=false
      endif
      if rotatedright and not rotatedleft then
        value=fix(min(maxSensor,value+1))
        rotatedright=false
      endif
    else 'only pRE_C active
      if resetenc and not rotatedleft then
        rotatedright=true
        resetenc=false
      endif
    endif
  else
    if pin1 then 'only pRE_D active
      if resetenc and not rotatedright then
        rotatedleft=true
        resetenc=false
      endif
    else 'both off so reset
      rotatedleft=false
      rotatedright=false
      resetenc=true
    endif
  endif
  if pin(pRE_C)=pin0 or pin(pRE_D)=pin1 then 
    goto rint2 're-enter if another change has happened almost immediately
  endif
end sub

